// Program: Lesson 30 - Excercise 4

#include <iostream.h>

enum occupied_t { yes, no };

template <class T>
class tree
{
 public:
	tree(void);
	~tree();
	void add(T t);
	void print(void);

 private:
	tree<T>* left;
	tree<T>* right;
	T	 item;

	// a tree node can be in two states:
	// (1) occupied=no: the leaf does not contain a valid ITEM
	// (2) occupied=yes: the node contains a valid ITEM
	// when a TREE object is instansiated, it does not contain
	// a valid item.
	occupied_t	occupied;
 };


template <class T>
tree<T>::tree(void)
 {
	left = NULL;
	right = NULL;
	occupied = no;
 }

template <class T>
tree<T>::~tree()
 {
	if (left != NULL)
	  delete left;
	if (right != NULL)
	  delete right;
 }

template <class T>
void tree<T>::add(T t)
 {
	if (occupied == no)
	 {
	  item = t;
	  occupied = yes;
	  return;
	 }

	if (t < item) {
		if (left == NULL)
		  left = new tree<T>;
		left -> add(t);
		}
	else
		{
		if (right == NULL)
		  right = new tree<T>;
		right -> add(t);
		}
 }

template <class T>
void tree<T>::print(void)
 {
    // use recursion to display the entire tree, in sorted order --
    // by using the depth-first-search (DFS) graph traversal policy
    if (left != NULL)
      left -> print();

    if (occupied == yes)
      cout << item << " ";

    if (right != NULL)
      right -> print();
 }

void main(void)
 {
    tree<int> t;

    t.add(1);
    t.add(5);
    t.add(61);
    t.add(-1);
    t.add(13);
    t.add(-7);
    t.print();
 }
