// Program: Lesson 31, Exercise 2

#include <iostream.h>

class cell // a stack element -- consists of a value of type int and a
 {         // pointer to the previous stack element (a cell itself)
    public:
      cell(void);
      cell(int val, cell* ptr);
      void set(int val);
      int  get(void);
      void connect (cell* ptr);
      cell* prev_cell(void);

    private:
      int value;
      cell* prev;
 };

cell::cell(void)                { prev = NULL; }
cell::cell(int val, cell* ptr)  { value = val; prev = ptr; }
void cell::set(int val)         { value = val; }
int  cell::get(void)            { return value; }
void cell::connect(cell* ptr)   { prev = ptr; }
cell* cell::prev_cell(void)     { return prev; }

class stack
 {
    public:
      stack(void);
      ~stack(void);
      void  push (int val);
      int   pop  (void);
      int   empty(void);
      void  print(void);

    private:
      cell* head;
 };

stack::stack(void)
 {
   cout << "stack created" << endl;
   head = NULL;
 }

stack::~stack(void)
 {
   cout << "stack destroyed" << endl;
   while (head)
    {
     cell *tmp_ptr = head -> prev_cell();
     delete head;
     head = tmp_ptr;
    }
 }

void stack::push(int val)
 {
   cell* tmp = new cell(val, head);
   head = tmp;
 }

int stack::pop(void)
 {
   if (empty()) return -1;

   int tmp_int = head -> get();
   cell* tmp_ptr = head;
   head = head -> prev_cell();
   delete tmp_ptr;
   return tmp_int;
 }

int stack::empty(void)
 {
   if (head == NULL)
     return 1;
   else
     return 0;
 }

void stack::print(void)
 {
   if (empty())
     cout << "empty!";
   else
    {
     cell* tmp_ptr = head;
     do {
	 cout << tmp_ptr->get() << " ";
	 tmp_ptr = tmp_ptr -> prev_cell();
      } while (tmp_ptr != NULL);
    }
   cout << endl;
 }


void main(void)
 {
   stack S;

   S.push(5);   S.push(7);   S.push(9);
   S.print();
   cout << S.pop() << endl;
   S.print();
   S.pop();
   S.print();
   cout << S.pop() << endl;
   S.pop();   // poping the empty stack
   S.print();
 }


