#include <iostream.h>
#include <stdlib.h>

template<class T, class T1> 
class array {
 public:
   array(int size);
   T1 sum(void);
   T average_value(void);
   void show_array(void);
   int add_value(T);
 private:
   T *data;
   int size;
   int index;
 };

template<class T, class T1> 
array<T, T1>::array(int size)
 {
    data = new T[size];

    if (data == NULL)
     {
       cerr << "Insufficient memory--program ending" << endl;
       exit(1);
     }

    array::size = size;
    array::index = 0;
 }

template<class T, class T1> 
T1 array<T, T1>::sum(void)
 {
    T1 sum = 0;
    int i;

    for (i = 0; i < index; i++)
      sum += data[i];  
 
    return(sum);
 }

template<class T, class T1> 
T array<T, T1>::average_value(void)
 {
    T1 sum = 0;
    int i;

    for (i = 0; i < index; i++)
      sum += data[i];

    return(sum / index);
 }


template<class T, class T1> 
void array<T, T1>::show_array(void)
 {
   int i;

   for (i = 0; i < index; i++)
     cout << data[i] << ' ';

   cout << endl;
 }

template<class T, class T1> 
int array<T, T1>::add_value(T value) 
 {
   if (index == size)
     return(-1);       // Array is full
   else
     {
       data[index] = value;
       index++;  
       return(0);     // Successful
     }
 }

void main(void)
 {
   array<int, long> numbers(100);   // 100 element array
   array<float, float> values(200); // 200 element array
   int i;

   for (i = 0; i < 50; i++)
     numbers.add_value(i);

   numbers.show_array();

   cout << "The sum of the numbers is " << numbers.sum() << endl;
   cout << "The average value is " << numbers.average_value() << endl;

   for (i = 0; i < 100; i++)
	  values.add_value(i * 100.0f);

   values.show_array();

   cout << "The sum of the numbers is " << values.sum() << endl;
   cout << "The average value is " << values.average_value() << endl;
 }

   
